clear all

global EM_USB;
EM_USB = serial('COM17','Baudrate',115200,'Databits',8);
fopen(EM_USB);

api_version = GetAPIVersion();
disp(['api_version = ' , num2str(api_version)]);

% Calling GetAbsPosition() screws up subsequent calls to GetAPIVersion()
% and other Get.... functions
ZeroAbsPosition();
pause(0.1);
encoder_angle = GetAbsPosition();
disp(['encoder_angle = ' , num2str(encoder_angle)]);

current_IU = GetCurrent(0);
current_IV = GetCurrent(1);
current_IW = GetCurrent(2);
current_I_DC = GetCurrent(3);
current_I1 = GetCurrent(4);
current_I2 = GetCurrent(5);
disp(['current_IU = ' , num2str(current_IU)]);
disp(['current_IV = ' , num2str(current_IV)]);
disp(['current_IW = ' , num2str(current_IW)]);
disp(['current_I_DC = ' , num2str(current_I_DC)]);
disp(['current_I1 = ' , num2str(current_I1)]);
disp(['current_I2 = ' , num2str(current_I2)]);

encoder_speed = GetRPM();
disp(['encoder_speed = ' , num2str(encoder_speed) , ' RPM']);

% Calling GetLoadCell() for torque and raw_reading
% does not work (always returns zero
% also - calling GetLoadCell(0) followed immediately by GetLoadCell(1)
% causes other Get..... calls to return garbage data
ZeroLoadCell();
pause(0.1);
load_cell_grams = GetLoadCell(0);
load_cell_torque = GetLoadCell(1);
load_cell_raw_reading = GetLoadCell(2);
disp(['load_cell_grams = ' , num2str(load_cell_grams) , ' grams']);
disp(['load_cell_torque = ' , num2str(load_cell_torque) , ' mNm ?']);
disp(['load_cell_raw_reading = ' , num2str(load_cell_raw_reading) , ' Raw']);

motor_direction = GetMotorDirection();
disp(['motor_direction = ' , num2str(motor_direction)]);

phase_U  = GetPhaseAngle(0);
phase_V  = GetPhaseAngle(1);
phase_W  = GetPhaseAngle(2);
phase_SP = GetPhaseAngle(3);
phase_1  = GetPhaseAngle(4);
phase_2  = GetPhaseAngle(5);
disp(['phase_U = ' , num2str(phase_U)]);
disp(['phase_V = ' , num2str(phase_V)]);
disp(['phase_W = ' , num2str(phase_W)]);
disp(['phase_SP = ' , num2str(phase_SP)]);
disp(['phase_1 = ' , num2str(phase_1)]);
disp(['phase_2 = ' , num2str(phase_2)]);

apparent_power_1 = GetPower(0);
apparent_power_2 = GetPower(1);
disp(['apparent_power_1 = ' , num2str(apparent_power_1) , ' VA']);
disp(['apparent_power_2 = ' , num2str(apparent_power_2) , ' VA']);

switch_state = GetSwitches ();
disp(['switch_state = ' , num2str(switch_state)]);

voltage_1 = GetVoltage(0);
voltage_2 = GetVoltage(1);
disp(['voltage_1 = ' , num2str(voltage_1) , ' V']);
disp(['voltage_2 = ' , num2str(voltage_2) , ' V']);

ZeroAbsPosition();

SetActive(0);                    % Motor OFF
pause(0.1);
SetActive(1);                    % Motor ON
pause(0.1);
SetActive(0);                    % Motor OFF

SetCapacitorBank(0);             % OFF
pause(0.1);
SetCapacitorBank(1);             % RUN
pause(0.1);
SetCapacitorBank(2);             % START
pause(0.1);
SetCapacitorBank(0);             % OFF

SetFrequency(50);                % 50Hz

SetMotorDirection(0);            % Clockwise

SetMotorType (0);                % DC Motor
SetMotorType (1);                % Single Phase
SetMotorType (2);                % Three Phase
SetMotorType (3);                % Reversible DC

SetPhase(0,0);                   % L1   0 Degrees
SetPhase(1,120);                 % L2 120 Degrees
SetPhase(2,240);                 % L3 240 Degrees

SetDynoLoad(127);            % Max Resistance = Minimum Load
pause(0.1);
SetDynoLoad( 63);            % Medium Load
pause(0.1);
SetDynoLoad( 32);            % High Load
pause(0.1);

SetSeriesResistor(0);            %  0 Ohms
pause(0.1);
SetSeriesResistor(1);            % 10 Ohms
pause(0.1);

SetVoltage (10);                 % 10V
pause(0.1);
SetVoltage (0);                  % 0V

ZeroLoadCell();                  % Calibrate Load Cell with no Load

SetActive(0);                    % Motor OFF
pause(0.1);

api_version = GetAPIVersion();
disp(['api_version = ' , num2str(api_version)]);

load_cell_grams = GetLoadCell(0);
disp(['load_cell_grams = ' , num2str(load_cell_grams) , ' grams']);

api_version = GetAPIVersion();
disp(['api_version = ' , num2str(api_version)]);

api_version = GetAPIVersion();
disp(['api_version = ' , num2str(api_version)]);

api_version = GetAPIVersion();
disp(['api_version = ' , num2str(api_version)]);

fclose(EM_USB)







